#include "SwfData.h"
#include <stdio.h>
#include <string.h> 
#include "zlib\zlib.h"


SwfData::SwfData(void)
{
}

SwfData::~SwfData(void)
{


}

bool SwfData::ReadData(const char* szFile) 
{
	bool bRet = true  ; 

	//otvaranje  ulaznog fajla 
	FILE *swfFile = fopen(szFile,"rb") ; 
	
	if (swfFile == NULL ) return false ; 

	fseek (swfFile, 0, SEEK_END);
	
	// lFileSize = velicina  ulazno fajla 
    long lFileSize = ftell(swfFile) ;

	byte* pFile = new byte[lFileSize] ;
	
	// vracanje na pocetak fajla 
	rewind (swfFile);
	
	// citanje fajla u bafer ...
	size_t szBytesRead = fread(pFile,1,lFileSize,swfFile) ; 
	if (szBytesRead != lFileSize)
	{
		fclose(swfFile);
		return false ; 
	}
	fclose(swfFile);
	
	// kopiranje swf headera iz fajla 
	memcpy(&header,pFile,sizeof(SwfHeader)) ; 

	// provera da li je fajl kompresovan 
	if (header.szSignature[0] == 'C') //compressed file 
	{
		
		// velicina nekompresovanog swf fajla 
		uint nFileLen = header.uFileLen ; 
		
		// bafer za nekompresovani fajl 
		byte* pFileUncompress= new byte[nFileLen] ; 

		//kopiranje headera u nekompresovani bafer 
		memcpy(pFileUncompress,&header,sizeof(SwfHeader)) ; 
		
		// offset pointera  od pocetka nekompresovanog fajla tj. preskakanje header podataka )
		pFileUncompress += sizeof(SwfHeader) ; 
		
		// offset pointera  od pocetka komresovanog (originalnog) fajla-preskakanje header podataka
		pFile += sizeof(SwfHeader) ; 
		
		//velicina nekompresovanog bloka bez hedera 
		dword dwDestLen = nFileLen - sizeof(SwfHeader) ; 

		//velicina kompresovanog bloka bez hedera 
		dword dwSrcLen = lFileSize - sizeof(SwfHeader) ; 

		if (uncompress(pFileUncompress,&dwDestLen,pFile,dwSrcLen) == Z_OK)
		{
			SwfStream stream(pFileUncompress,nFileLen) ; 
			//citanje dimenzije flash fajla 
			m_rect.ReadSize(stream) ; 
			// frame rate 
			m_FPS = stream.ReadFloatWord(8,8) ; 
			m_frames = stream.ReadUInt16();

		
		}
		else 
			bRet=false ; 

		//vracamo  offset pointer na nulu  od nekompresovanog fajla  zbog dealociranja memorije 
		pFileUncompress -= sizeof(SwfHeader) ; 
		
		//vracamo offset pointer na nulu od kompresovanog(originalnog fajla) zbog dealociranja memorije 
		pFile -= sizeof(SwfHeader) ; 
			
		delete [] pFileUncompress ; 
		delete [] pFile ; 

	}
	else 
	{
		//ako fajl verzije < 6.0  nije kompresovan citanje po defaultu 
		byte* pOrigin  = pFile + sizeof(SwfHeader); 
		SwfStream stream(pOrigin,lFileSize) ; 
		m_rect.ReadSize(stream) ; 
		stream.SynchBits() ;
		m_FPS = stream.ReadFloatWord(8,8) ; 
		delete [] pFile ; 
		

	}
  	return bRet ; 
}
