#pragma once

#include "SwfStream.h" 

//struktura header *.swf fajla 
struct SwfHeader
{
	uchar szSignature [3] ;//signature od fajla uglavnom je CWS za verzije flash-a >6.0
	uchar szVersion ; // verzija 
	uint  uFileLen ; // velicina nekompresovanog fajla 
} ;

// klasa SwfRect u kojoj su koeficijenti dimenzija flash  animacije 
class SwfRect 
{
public: 
	SwfRect() : 
	  nBits(0),xMin(0),yMin(0), 
	  xMax(0),yMax(0) 
	  {
	  
	  } 
	~SwfRect() {} 

	void ReadSize (SwfStream& stream)
	{
		nBits =stream.ReadUBits(5);
        xMin = stream.ReadSBits(nBits);
        xMax = stream.ReadSBits(nBits);
        yMin = stream.ReadSBits(nBits);
        yMax = stream.ReadSBits(nBits);
	}
	int getWidth () { 
	 	 return (xMax / 20) - (xMin /20 ); 
	}
	int getHeight() { 
		return (yMax / 20) -  (yMin / 20) ; 	
	}
private : 
	int nBits ;
    int xMin ;
    int xMax ;
    int yMin ;
    int yMax ;
};





class SwfBackColor 
{
#define rgb(r,g,b)   ((dword)(((byte)(r)|((ushort)((byte)(g))<<8))|(((dword)(byte)(b))<<16)))

public : 
	SwfBackColor():red(0),green(0),blue(0){} 
	~SwfBackColor(){} 

public: 
	dword ReadBackColor (SwfStream& stream) { 
		red =  stream.ReadByte() ;  
		green =  stream.ReadByte() ; 
		blue = stream.ReadByte() ; 
		return rgb(red,green,blue) ; 
	}  

private : 
	uchar red,green,blue ; 

}; 