#include "SwfStream.h"
#include "string.h" 


SwfStream::SwfStream(byte* pMemFile,uint nFileLen) :
	m_pStartPos(pMemFile), 
	m_pCurrentPos(pMemFile),
	m_nFileLen(nFileLen),
	m_nCurOffset(0),
	bitBuf(0),
	bitPos(0)
{

}

SwfStream::~SwfStream(void)
{
	m_pCurrentPos = m_pStartPos ; 
}

uchar SwfStream::ReadByte () 
{
	uchar value = 0 ; 
	memcpy(&value,m_pCurrentPos,sizeof(uchar)) ;
	Seek(sizeof(uchar)) ; 
	return value ; 
}

uchar* SwfStream::ReadString(int nCount) 
{
	uchar* szStr = new uchar[nCount+1] ; 
	szStr[nCount] = '\0';
	memcpy(szStr,m_pCurrentPos,sizeof(uchar)* nCount) ;
	Seek(sizeof(uchar)* nCount) ; 
	return szStr ; 
}

int SwfStream::ReadUBits (int bits) 
{
	uint  v = 0;

    while (true)
    {
        int s = (int)(bits - bitPos);

        if (s > 0)
        {
            v |= bitBuf << s;
            bits -= (uint)bitPos;

            bitBuf = ReadByte();
            bitPos = 8;
        }
        else
        {
            v |= bitBuf >> -s;

            bitPos -= (int)bits;
            bitBuf &= (uint)(0xff >> (8 - bitPos));

            return v;
        }
    }

}
int SwfStream::ReadSBits (int bits) 
{
    int v = (int)(ReadUBits(bits));

    if ((v & (1L << (int)(bits - 1))) > 0)
    {
        v |= -1 << (int)bits;
    }

    return v;

}
uint SwfStream::ReadUInt32 () 
{
	uint value ;
	SynchBits() ; 
	memcpy(&value,m_pCurrentPos,sizeof(uint)) ; 
	Seek(sizeof(uint)) ; 
	return value; 
}
ushort SwfStream::ReadUInt16() 
{
	ushort value ;
	SynchBits() ; 
	memcpy(&value,m_pCurrentPos,sizeof(ushort)) ;
	Seek(sizeof(ushort)) ; 
	return value; 

}
float SwfStream::ReadFloatWord(uint mantissaSize, uint fractionSize)
{
    int mantissa = 0;
    int fraction = 0;
    
    float value = 0;
    float divisor = (float)(1 << (int)fractionSize);

	SynchBits() ; 

    fraction = (int)ReadUBits(fractionSize);
    mantissa = (int)ReadSBits(mantissaSize);
    
    mantissa <<= (int)fractionSize;   
    value = (mantissa + fraction) / divisor;
    
    return value;
}
void SwfStream::SynchBits()
{
    bitBuf = 0;
    bitPos = 0;
}
bool SwfStream::SeekToBegin () 
{
	if (m_nCurOffset <= m_nFileLen ){ 
		m_pCurrentPos -= m_nCurOffset ;  
		m_nCurOffset= 0 ; 
		return true; 
	}
	else 
	 return false ; 
	
}
bool SwfStream::SeekToEnd () 
{
	if (m_nCurOffset <= m_nFileLen){
		m_pCurrentPos += (m_nFileLen - m_nCurOffset) ; 
		m_nCurOffset = m_nFileLen ; 
		return true;
	}
	else
		return false ;
}
bool SwfStream::Seek (int offset,int nStart)
{
	if ((m_nCurOffset + offset) <= m_nFileLen && (m_nCurOffset + offset) >= 0 ){	
		m_pCurrentPos += (offset + nStart) ; 
		m_nCurOffset += offset + nStart ; 
		return true ; 
	}
	else 
		return false ; 

}
